From 01fb84c6e8e2cecbedbce08d9acba7e1538e70bf Mon Sep 17 00:00:00 2001
From: Ryan Zezeski <ryan@zinascii.com>
Date: Wed, 7 Jan 2026 10:19:36 -0500
Subject: [PATCH] 17526 cxgbe could use more queues 17527 cxgbe should be
 smatch clean 17528 cxgbe should always be mac ring capable Portions
 contributed by: Patrick Mooney <pmooney@pfmooney.com> Reviewed by: Robert
 Mustacchi <rm@fingolfin.org>

Change-Id: I719cb8b599b7de95d65055d65367a704e22b8d9c
---
 usr/src/uts/common/io/cxgbe/common/common.h   |    2 +-
 usr/src/uts/common/io/cxgbe/common/t4_hw.c    |   30 +-
 usr/src/uts/common/io/cxgbe/shared/shared.h   |    4 +-
 usr/src/uts/common/io/cxgbe/t4nex/adapter.h   |  966 +++---
 usr/src/uts/common/io/cxgbe/t4nex/cudbg.h     |    2 +-
 usr/src/uts/common/io/cxgbe/t4nex/cudbg_lib.c |    2 +-
 usr/src/uts/common/io/cxgbe/t4nex/t4_ioctl.c  |    1 -
 usr/src/uts/common/io/cxgbe/t4nex/t4_mac.c    |  371 +--
 usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c  | 2357 ++++++++------
 usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c    | 2894 +++++++++--------
 usr/src/uts/intel/cxgbe/t4nex/Makefile        |    9 +-
 11 files changed, 3820 insertions(+), 2818 deletions(-)

diff --git a/usr/src/uts/common/io/cxgbe/common/common.h b/usr/src/uts/common/io/cxgbe/common/common.h
index 22a28e4a3d..cabe280784 100644
--- a/usr/src/uts/common/io/cxgbe/common/common.h
+++ b/usr/src/uts/common/io/cxgbe/common/common.h
@@ -583,7 +583,7 @@ unsigned int t4_link_fwcap_to_speed(fw_port_cap32_t caps);
 fw_port_cap32_t t4_link_fwcap_to_fwspeed(fw_port_cap32_t acaps);
 int t4_link_set_autoneg(struct port_info *pi, u8 autoneg,
 			fw_port_cap32_t *new_caps);
-int t4_link_set_pause(struct port_info *pi, cc_pause_t pause,
+void t4_link_set_pause(struct port_info *pi, cc_pause_t pause,
 		      fw_port_cap32_t *new_caps);
 int t4_link_set_fec(struct port_info *pi, cc_fec_t fec,
 		    fw_port_cap32_t *new_caps);
diff --git a/usr/src/uts/common/io/cxgbe/common/t4_hw.c b/usr/src/uts/common/io/cxgbe/common/t4_hw.c
index 9fb9f9301c..7757fd0b51 100644
--- a/usr/src/uts/common/io/cxgbe/common/t4_hw.c
+++ b/usr/src/uts/common/io/cxgbe/common/t4_hw.c
@@ -449,7 +449,7 @@ int t4_wr_mbox_meat_timeout(struct adapter *adap, int mbox, const void *cmd,
 	u32 ctl_reg = PF_REG(mbox, A_CIM_PF_MAILBOX_CTRL);
 	u32 ctl;
 	__be64 cmd_rpl[MBOX_LEN/8];
-	struct t4_mbox_list entry;
+	t4_mbox_waiter_t entry;
 	u32 pcie_fw;
 
 	if ((size & 15) || size > MBOX_LEN)
@@ -469,7 +469,7 @@ int t4_wr_mbox_meat_timeout(struct adapter *adap, int mbox, const void *cmd,
 	 * wait [for a while] till we're at the front [or bail out with an
 	 * EBUSY] ...
 	 */
-	t4_mbox_list_add(adap, &entry);
+	t4_mbox_waiter_add(adap, &entry);
 
 	for (i = 0; ; i++) {
 		/*
@@ -481,28 +481,15 @@ int t4_wr_mbox_meat_timeout(struct adapter *adap, int mbox, const void *cmd,
 		 */
 		pcie_fw = t4_read_reg(adap, A_PCIE_FW);
 		if (i > 4*timeout || (pcie_fw & F_PCIE_FW_ERR)) {
-			t4_mbox_list_del(adap, &entry);
+			t4_mbox_waiter_remove(adap, &entry);
 			t4_report_fw_error(adap);
 			ret = (pcie_fw & F_PCIE_FW_ERR) ? -ENXIO : -EBUSY;
 			T4_RECORD_MBOX(adap, cmd, size, ret, 0);
 			return ret;
 		}
 
-		/*
-		 * If we're at the head, break out and start the mailbox
-		 * protocol.
-		 */
-		if (t4_mbox_list_first_entry(adap) == &entry)
+		if (t4_mbox_wait_owner(adap, MBOX_CMD_DELAY, sleep_ok)) {
 			break;
-
-		/*
-		 * Delay for a bit before checking again ...
-		 */
-		if (sleep_ok) {
-			usleep_range(MIN_MBOX_CMD_DELAY, MBOX_CMD_DELAY);
-		} else {
-			T4_OS_TOUCH_NMI_WATCHDOG();
-			udelay(MBOX_CMD_DELAY);
 		}
 	}
 #ifdef T4_OS_LOG_MBOX_CMDS
@@ -524,7 +511,7 @@ int t4_wr_mbox_meat_timeout(struct adapter *adap, int mbox, const void *cmd,
 	 * mailbox atomic access list and report the error to our caller.
 	 */
 	if (v != X_MBOWNER_PL) {
-		t4_mbox_list_del(adap, &entry);
+		t4_mbox_waiter_remove(adap, &entry);
 		t4_report_fw_error(adap);
 		ret = (v == X_MBOWNER_FW) ? -EBUSY : -ETIMEDOUT;
 		T4_RECORD_MBOX(adap, cmd, size, access, ret);
@@ -597,7 +584,7 @@ int t4_wr_mbox_meat_timeout(struct adapter *adap, int mbox, const void *cmd,
 			 */
 			get_mbox_rpl(adap, cmd_rpl, size/8, data_reg);
 			t4_write_reg(adap, ctl_reg, V_MBOWNER(X_MBOWNER_NONE));
-			t4_mbox_list_del(adap, &entry);
+			t4_mbox_waiter_remove(adap, &entry);
 
 			T4_RECORD_MBOX(adap, cmd_rpl, size, access, i + 1);
 
@@ -625,7 +612,7 @@ int t4_wr_mbox_meat_timeout(struct adapter *adap, int mbox, const void *cmd,
 	 * the error and also check to see if the firmware reported any
 	 * errors ...
 	 */
-	t4_mbox_list_del(adap, &entry);
+	t4_mbox_waiter_remove(adap, &entry);
 
 	ret = (pcie_fw & F_PCIE_FW_ERR) ? -ENXIO : -ETIMEDOUT;
 	T4_RECORD_MBOX(adap, cmd, size, access, ret);
@@ -9099,7 +9086,7 @@ int t4_link_set_autoneg(struct port_info *pi, u8 autoneg,
 	return 0;
 }
 
-int t4_link_set_pause(struct port_info *pi, cc_pause_t pause,
+void t4_link_set_pause(struct port_info *pi, cc_pause_t pause,
 		      fw_port_cap32_t *new_caps)
 {
 	struct link_config *lc = &pi->link_cfg;
@@ -9128,7 +9115,6 @@ int t4_link_set_pause(struct port_info *pi, cc_pause_t pause,
 		caps |= FW_PORT_CAP32_FORCE_PAUSE;
 
 	*new_caps = caps;
-	return 0;
 }
 
 #define T4_LINK_FEC_MASK V_FW_PORT_CAP32_FEC(M_FW_PORT_CAP32_FEC)
diff --git a/usr/src/uts/common/io/cxgbe/shared/shared.h b/usr/src/uts/common/io/cxgbe/shared/shared.h
index 8a1f682be0..158728427f 100644
--- a/usr/src/uts/common/io/cxgbe/shared/shared.h
+++ b/usr/src/uts/common/io/cxgbe/shared/shared.h
@@ -21,7 +21,7 @@
  */
 
 /*
- * Copyright 2024 Oxide Computer Company
+ * Copyright 2025 Oxide Computer Company
  */
 
 #ifndef __CXGBE_SHARED_H
@@ -51,7 +51,7 @@
 #define	CH_DBG(sc, category, fmt, ...)		do {} while (0)
 #endif
 
-extern int cxgb_printf(dev_info_t *dip, int level, char *f, ...);
+extern void cxgb_printf(dev_info_t *dip, int level, char *f, ...);
 
 /* Attach/detach logic used by cxgbe, calling into t4nex */
 struct port_info;
diff --git a/usr/src/uts/common/io/cxgbe/t4nex/adapter.h b/usr/src/uts/common/io/cxgbe/t4nex/adapter.h
index ea147b19da..34659a32c6 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/adapter.h
+++ b/usr/src/uts/common/io/cxgbe/t4nex/adapter.h
@@ -30,129 +30,122 @@
 #include <sys/ddi.h>
 #include <sys/mac_provider.h>
 #include <sys/ethernet.h>
-#include <sys/queue.h>
+#include <sys/list.h>
 #include <sys/containerof.h>
 #include <sys/ddi_ufm.h>
+#include <sys/mac_provider.h>
 
 #include "firmware/t4fw_interface.h"
 #include "shared.h"
 
 struct adapter;
+struct port_info;
 typedef struct adapter adapter_t;
+struct sge_fl;
+
+/* See the _Ingress Context Contents_ section of the T4 Programmers Guide. */
+typedef enum t4_iq_esize {
+	T4_IQ_ESIZE_16B = 0,
+	T4_IQ_ESIZE_32B = 1,
+	T4_IQ_ESIZE_64B = 2,
+	T4_IQ_ESIZE_128B = 3,
+} t4_iq_esize_t;
 
 #define	FW_IQ_QSIZE	256
-#define	FW_IQ_ESIZE	64	/* At least 64 mandated by the firmware spec */
+/* At least 64 bytes mandated by the firmware spec */
+#define	FW_IQ_ESIZE	T4_IQ_ESIZE_64B
+
+#define	T4_RX_DEF_QSIZE	1024
+/* At least 64 so CPL_RX_PKT will fit */
+#define	RX_IQ_ESIZE	T4_IQ_ESIZE_64B
+
+/* A flit is an 8 byte quantity. */
+#define	FLIT_NUM_BYTES		8
+#define	FLITS_TO_BYTES(nflits)	((nflits) * FLIT_NUM_BYTES)
 
-#define	RX_IQ_QSIZE	1024
-#define	RX_IQ_ESIZE	64	/* At least 64 so CPL_RX_PKT will fit */
+/*
+ * Egress Queues (EQ) are made up of units called "host credits". Each credit is
+ * always 8 flits (64 bytes) in size. The number of entries in the queue as well
+ * as the producer and consumer indexes (pidx/cidx) are phrased in units of
+ * credits.
+ *
+ * A freelist (FL) is a type of EQ. It consists of 16-byte aligned, 8-byte
+ * pointers to data buffers meant to hold the data of incoming packets. Since an
+ * EQ host credit is always 8 flits, and an FL buffer pointer is a single flit,
+ * each credit holds 8 FL buffer pointers.
+ *
+ */
+#define	FLITS_PER_EQ_HC		8
+#define	EQ_HC_SIZE		FLITS_PER_EQ_HC * FLIT_NUM_BYTES
+#define	FL_BUF_PTR_PER_HC	FLITS_PER_EQ_HC
 
-#define	EQ_ESIZE	64	/* All egress queues use this entry size */
+/*
+ * Given a number of host credits, calculate the total number of flits
+ * contained in those credits.
+ */
+#define	EQ_HC_TO_FLITS(num_credits)	((num_credits) * FLITS_PER_EQ_HC)
 
-#define	RX_FL_ESIZE	64	/* 8 64bit addresses */
+/*
+ * Given a number of flits, calculate how many host credits are needed to hold
+ * them.
+ */
+#define	EQ_FLITS_TO_HC(num_flits)	(howmany(num_flits, FLITS_PER_EQ_HC))
 
-#define	FL_BUF_SIZES	4
+/*
+ * We constrain the max "usable" EQ size so that there is always room for the
+ * status page, which may require 1-2 host credits.
+ */
+#define	T4_MAX_EQ_SIZE		(UINT16_MAX - 2)
+#define	T4_TX_DEF_QSIZE		1024
+#define	TX_SGL_SEGS		36
 
-#define	CTRL_EQ_QSIZE	128
+/* The maximum number of flits/credits a single WR may consume. */
+#define	TX_WR_MAX_FLITS		(SGE_MAX_WR_LEN / FLIT_NUM_BYTES)
+#define	TX_WR_MAX_CREDITS	(TX_WR_MAX_FLITS / FLITS_PER_EQ_HC)
 
-#define	TX_EQ_QSIZE	1024
-#define	TX_SGL_SEGS	36
-#define	TX_WR_FLITS	(SGE_MAX_WR_LEN / 8)
+CTASSERT(TX_WR_MAX_FLITS == 64);
+CTASSERT(TX_WR_MAX_CREDITS == 8);
 
 #define	UDBS_SEG_SHIFT	7	/* log2(UDBS_SEG_SIZE) */
 #define	UDBS_DB_OFFSET	8	/* offset of the 4B doorbell in a segment */
 #define	UDBS_WR_OFFSET	64	/* offset of the work request in a segment */
 
-typedef enum t4_port_flags {
-	TPF_INIT_DONE	= (1 << 0),
-	TPF_OPEN	= (1 << 1),
-} t4_port_flags_t;
-
-typedef enum t4_port_feat {
-	CXGBE_HW_LSO	= (1 << 0),
-	CXGBE_HW_CSUM	= (1 << 1),
-} t4_port_feat_t;
-
-struct port_info {
-	dev_info_t *dip;
-	mac_handle_t mh;
-	mac_callbacks_t *mc;
-	int mtu;
-	uint8_t hw_addr[ETHERADDRL];
-
-	kmutex_t lock;
-	struct adapter *adapter;
-
-	t4_port_flags_t flags;
-
-	uint16_t viid;
-	int16_t  xact_addr_filt; /* index of exact MAC address filter */
-	uint16_t rss_size;	/* size of VI's RSS table slice */
-	uint16_t ntxq;		/* # of tx queues */
-	uint16_t first_txq;	/* index of first tx queue */
-	uint16_t nrxq;		/* # of rx queues */
-	uint16_t first_rxq;	/* index of first rx queue */
-	uint8_t  lport;		/* associated offload logical port */
-	int8_t   mdio_addr;
-	uint8_t  port_type;
-	uint8_t  mod_type;
-	uint8_t  port_id;
-	uint8_t  tx_chan;
-	uint8_t  rx_chan;
-	uint8_t  rx_cchan;
-	uint8_t instance; /* Associated adapter instance */
-	uint8_t child_inst; /* Associated child instance */
-
-	uint8_t	tmr_idx;
-	int8_t	pktc_idx;
-	uint8_t	dbq_timer_idx;
-
-	struct link_config link_cfg;
-	struct port_stats stats;
-	t4_port_feat_t features;
-	uint8_t macaddr_cnt;
-	u8 rss_mode;
-	u16 viid_mirror;
-	kstat_t *ksp_config;
-	kstat_t *ksp_info;
-	kstat_t *ksp_fec;
-
-	u8 vivld;
-	u8 vin;
-	u8 smt_idx;
+/*
+ * A sentinel to mark when the interrupts for an IQ are being forwarded from
+ * another IQ which is receiving the actual interrupt.
+ */
+#define	INTR_FORWARDED	UINT_MAX
 
-	u8 vivld_mirror;
-	u8 vin_mirror;
-	u8 smt_idx_mirror;
+struct fl_desc {
+	uint64_t dptr[FL_BUF_PTR_PER_HC];
 };
 
 struct fl_sdesc {
 	struct rxbuf *rxb;
 };
 
-struct tx_desc {
-	__be64 flit[8];
-};
+typedef struct t4_eq_host_credit {
+	uint64_t flit[8];
+} t4_eq_host_credit_t;
 
 struct tx_sdesc {
 	mblk_t *mp_head;
 	mblk_t *mp_tail;
 	uint32_t txb_used;	/* # of bytes of tx copy buffer used */
 	uint16_t hdls_used;	/* # of dma handles used */
-	uint16_t desc_used;	/* # of hardware descriptors used */
+	uint16_t credits_used;	/* # of EQ host credits used */
 	uint64_t _pad;
 };
 
 typedef enum t4_iq_flags {
-	IQ_ALLOCATED	= (1 << 0),	/* firmware resources allocated */
-	IQ_INTR		= (1 << 1),	/* iq takes direct interrupt */
-	IQ_HAS_FL	= (1 << 2),	/* iq has fl */
-} t4_iq_flags_t;
+	IQ_ALLOC_HOST	= (1 << 0),	/* host-side resources allocated */
+	IQ_ALLOC_DEV	= (1 << 1),	/* device-side resource allocated */
+	IQ_INTR		= (1 << 2),	/* iq takes direct interrupt */
 
-typedef enum t4_iq_state {
-	IQS_DISABLED	= 0,
-	IQS_BUSY	= 1,
-	IQS_IDLE	= 2,
-} t4_iq_state_t;
+	/* Runtime state flags: */
+	IQ_ENABLED	= (1 << 3),
+	IQ_POLLING	= (1 << 4),
+} t4_iq_flags_t;
 
 struct rxbuf_cache_params {
 	dev_info_t		*dip;
@@ -162,8 +155,8 @@ struct rxbuf_cache_params {
 };
 
 struct sge_iq_stats {
-	uint64_t sis_overflow;
-	uint64_t sis_processed;
+	uint64_t sis_processed;	/* # entries processed from IQ */
+	uint64_t sis_overflow;	/* # entries bearing overflow flag */
 };
 
 /*
@@ -172,141 +165,330 @@ struct sge_iq_stats {
  *
  * See: t4_iq_update_intr_cfg() and t4_iq_gts_update().
  */
-typedef enum t4_intr_config {
-	TIC_SE_INTR_ARM		= 1,
-	TIC_TIMER0		= (0 << 1),
-	TIC_TIMER1		= (1 << 1),
-	TIC_TIMER2		= (2 << 1),
-	TIC_TIMER3		= (3 << 1),
-	TIC_TIMER4		= (4 << 1),
-	TIC_TIMER5		= (5 << 1),
-	TIC_START_COUNTER	= (6 << 1),
-} t4_intr_config_t;
+typedef enum t4_gts_config {
+	TGC_SE_INTR_ARM		= 1,
+	TGC_TIMER0		= (0 << 1),
+	TGC_TIMER1		= (1 << 1),
+	TGC_TIMER2		= (2 << 1),
+	TGC_TIMER3		= (3 << 1),
+	TGC_TIMER4		= (4 << 1),
+	TGC_TIMER5		= (5 << 1),
+	TGC_START_COUNTER	= (6 << 1),
+} t4_gts_config_t;
 
 /*
- * Ingress Queue: T4 is producer, driver is consumer.
+ * Event IQs are used for firmware events, Tx EGR updates, and IQ forwarded
+ * interrupts.
+ *
+ * Ethernet Rx IQs are used for receiving incoming packets.
  */
-struct sge_iq {
-	t4_iq_state_t state;
-	t4_iq_flags_t flags;
-	t4_intr_config_t intr_params;
-
-	ddi_dma_handle_t dhdl;
-	ddi_acc_handle_t ahdl;
-
-	__be64 *desc;		/* KVA of descriptor ring */
-	uint64_t ba;		/* bus address of descriptor ring */
-	const __be64 *cdesc;	/* current descriptor */
-	struct adapter *adapter; /* associated  adapter */
-	uint8_t  gen;		/* generation bit */
-	int8_t   intr_pktc_idx;	/* packet count threshold index */
-	uint8_t  esize;		/* size (bytes) of each entry in the queue */
-	uint16_t qsize;		/* size (# of entries) of the queue */
-	uint16_t cidx;		/* consumer index */
-	uint16_t pending;	/* # of descs processed since last doorbell */
-	uint16_t cntxt_id;	/* SGE context id  for the iq */
-	uint16_t abs_id;	/* absolute SGE id for the iq */
-	kmutex_t lock;		/* Rx access lock */
-	uint8_t polling;
-
-	struct sge_iq_stats stats;
-
-	STAILQ_ENTRY(sge_iq) link;
+typedef enum t4_iq_type {
+	TIQT_UNINIT,
+	TIQT_EVENT,
+	TIQT_ETH_RX,
+} t4_iq_type_t;
+
+/* Ingress Queue: T4 is producer, driver is consumer. */
+typedef struct t4_sge_iq {
+	kmutex_t tsi_lock;
+
+	t4_iq_type_t tsi_iqtype; /* Write Once */
+	t4_iq_flags_t tsi_flags; /* tsi_lock */
+
+	/*
+	 * This field is non-NULL only for Rx queues. It points to the event
+	 * queue which receives interrupts on its behalf. The event queue
+	 * processes these "forwarded interrupts" in t4_process_event_iq() and
+	 * calls into t4_process_rx_iq() for each Rx queue with an interrupt
+	 * notification message.
+	 */
+	struct t4_sge_iq *tsi_intr_evtq; /* Write Once */
+	/*
+	 * This field is only used by the event queues.
+	 *
+	 * As the event queue processes forwarded interrupt notification
+	 * messages it adds the destination rx queue receving the notification
+	 * to this list. After the event queue finishes processing its own
+	 * messages, it then uses this list to process the rx queues which have
+	 * pending notifications.
+	 */
+	list_node_t tsi_intr_fwd_node; /* tsi_lock */
+	/*
+	 * This field is used by both event queues and rx queues.
+	 *
+	 * For event queues this field holds the interrupt vector assigned to
+	 * this queue.
+	 *
+	 * For rx queues it holds the sentinel value INTR_FORWARDED to indicate
+	 * it has its interrupts forwarded by the event queue. In the current
+	 * iteration of this driver all rx queues will always have their
+	 * interrupts forwarded.
+	 */
+	uint_t tsi_intr_idx;	/* Write Once */
+
+	ddi_dma_handle_t tsi_desc_dhdl; /* Write Once */
+	ddi_acc_handle_t tsi_desc_ahdl; /* Write Once */
+
+	/* KVA of descriptor ring */
+	void *tsi_desc;		/* Write Once */
+	/* bus address of descriptor ring */
+	uint64_t tsi_desc_ba;	/* Write Once */
+	/* current descriptor (at CIDX) */
+	const void *tsi_cdesc;	/* tsi_lock */
+
+	/* Sizing and status */
+	/* size of each entry in the queue */
+	t4_iq_esize_t tsi_esize;  /* Write Once */
+	/* entry size in bytes */
+	uint16_t tsi_esize_bytes; /* Write Once */
+	/* number of entries in the queue */
+	uint16_t tsi_qsize;	/* Write Once */
+	/* number of usable entries in the queue */
+	uint16_t tsi_cap;	/* Write Once */
+	/* consumer index */
+	uint16_t tsi_cidx;	/* tsi_lock */
+	/* generation bit */
+	uint8_t tsi_gen;	/* tsi_lock */
+
+	/* GTS config to re-arm queue notification */
+	t4_gts_config_t tsi_gts_rearm; /* tsi_lock */
+	/* packet count threshold index */
+	int8_t tsi_intr_pktc_idx; /* tsi_lock */
+
+	/* SGE context ID for IQ */
+	uint16_t tsi_cntxt_id;	/* Write Once */
+	/* absolute SGE ID for IQ */
+	uint16_t tsi_abs_id;	/* Write Once */
+
+	/* associated adapter */
+	struct adapter *tsi_adapter; /* Write Once */
+	/* associated freelist (if any) */
+	struct sge_fl *tsi_fl;	/* Write Once */
+
+	struct sge_iq_stats tsi_stats; /* tsi_lock */
+} t4_sge_iq_t;
+
+/* Result of servicing IQ in t4_iq_service() call */
+typedef enum t4_iq_result {
+	TIR_SUCCESS,	/* All available entries processed successfully */
+	TIR_DISABLED,	/* IQ is disabled */
+	TIR_POLLING,	/* non-polling service req'd on polling-cfg'd IQ */
+	TIR_ALLOC_FAIL,	/* could not allocate packet buffer(s) */
+	TIR_BUDGET_MAX,	/* hit budget limit while processing entries */
+} t4_iq_result_t;
+
+/*
+ * Details used when servicing an IQ as part of polling.
+ */
+struct t4_poll_req {
+	mblk_t	*tpr_mp;
+	uint_t	tpr_byte_budget;
 };
 
 typedef enum t4_eq_flags {
 	/* Initialization state flags: */
-	EQ_ALLOCATED	= (1 << 0),	/* firmware resources allocated */
-	EQ_MTX		= (1 << 1),	/* mutex has been initialized */
+	EQ_ALLOC_HOST	= (1 << 0),	/* host-side resources allocated */
+	EQ_ALLOC_DEV	= (1 << 1),	/* EQ allocated in device firmware */
+	EQ_ALLOC_DESC	= (1 << 2),	/* descriptor inputs allocated */
 
 	/* Runtime state flags: */
 
+	EQ_ENABLED	= (1 << 3),	/* ready for submitted work requests */
 	/*
 	 * Short on resources (memory and/or descriptors) while attempting to
 	 * enqueue work in EQ
 	 */
-	EQ_CORKED	= (1 << 2),
+	EQ_CORKED	= (1 << 4),
 } t4_eq_flags_t;
 
-/* Listed in order of preference. */
+/*
+ * These are the Egress Queue doorbell methods. They are listed in order of
+ * preference (WCWR most preferred, KDB least). This ordering is important as
+ * the datapath uses ffs (find first set) to pick the preferred method.
+ *
+ * The first three are "user space" doorbells. They are mapped in BAR2 and are
+ * provided to allow kernel-bypass network stacks. However, they can also be
+ * used in the kernel and provide benefits such as write combining and per-queue
+ * registers (versus KDB which is a single register).
+ *
+ * The WCWR, Write Combining Work Request, is the preferred method. It allows
+ * the driver to push a WR directly to the device without the need for it to
+ * perform a DMA read of the hardware ring (to read the EQ host credit). Instead
+ * it comes in via the BAR2/UDB memory space and the device increments the pidx
+ * accordingly. However, the WCWR is limited to a single WR. It's use is
+ * intended for low latency situations or low rate of work, not for throughput.
+ *
+ * The maximum WCWR for T4 is 256 bytes. For T5/T6 it is 64-128 bytes, depending
+ * on the write-combining size of the platform.
+ *
+ * T4 Firmware Interface Specification, §9.2 Egress Queues and Work Requests.
+ */
 typedef enum t4_doorbells {
-	DOORBELL_UDB	= (1 << 0),
-	DOORBELL_WCWR	= (1 << 1),
-	DOORBELL_UDBWC	= (1 << 2),
+	DOORBELL_WCWR	= (1 << 0),
+	DOORBELL_UDBWC	= (1 << 1),
+	DOORBELL_UDB	= (1 << 2),
 	DOORBELL_KDB	= (1 << 3),
 } t4_doorbells_t;
 
-/*
- * Egress Queue: driver is producer, T4 is consumer.
- *
- * Note: A free list is an egress queue (driver produces the buffers and T4
- * consumes them) but it's special enough to have its own struct (see sge_fl).
- */
-struct sge_eq {
-	ddi_dma_handle_t desc_dhdl;
-	ddi_acc_handle_t desc_ahdl;
-	t4_eq_flags_t flags;
-	kmutex_t lock;
+/* Egress Queue: driver is producer, T4 is consumer. */
+typedef struct t4_sge_eq {
+	kmutex_t tse_lock;
 
-	struct tx_desc *desc;	/* KVA of descriptor ring */
-	uint64_t ba;		/* bus address of descriptor ring */
-	struct sge_qstat *spg;	/* status page, for convenience */
-	t4_doorbells_t doorbells;
-	caddr_t udb;		/* KVA of doorbell (lies within BAR2) */
-	uint_t udb_qid;		/* relative qid within the doorbell page */
-	uint16_t cap;		/* max # of desc, for convenience */
-	uint16_t avail;		/* available descriptors, for convenience */
-	uint16_t qsize;		/* size (# of entries) of the queue */
-	uint16_t cidx;		/* consumer idx (desc idx) */
-	uint16_t pidx;		/* producer idx (desc idx) */
-	uint16_t pending;	/* # of descriptors used since last doorbell */
-	uint16_t iqid;		/* iq that gets egr_update for the eq */
-	uint8_t tx_chan;	/* tx channel used by the eq */
-	uint32_t cntxt_id;	/* SGE context id for the eq */
-};
+	t4_eq_flags_t tse_flags;	/* tse_lock */
 
-typedef enum t4_fl_flags {
-	FL_MTX		= (1 << 0),	/* mutex has been initialized */
-	FL_STARVING	= (1 << 1),	/* on the list of starving fl's */
-	FL_DOOMED	= (1 << 2),	/* about to be destroyed */
-} t4_fl_flags_t;
+	ddi_dma_handle_t tse_ring_dhdl; /* Write Once */
+	ddi_acc_handle_t tse_ring_ahdl; /* Write Once */
+
+	/*
+	 * The ring type is pointer to void because the ring does not consist of
+	 * descriptors but rather host credits. These host credits carry
+	 * variable length work requests (WR) as well as the status page (SP) at
+	 * the end of the ring. We use void* to facilitate the type punning
+	 * required to work with these various types of EQ entries.
+	 *
+	 * In order to access credits and their individual flits we make use to
+	 * the t4_eq_host_credit_t type.
+	 */
+	void *tse_ring;		/* KVA of ring - Write Once */
+	uint64_t tse_ring_ba;	/* bus address of ring - Write Once */
+
+	/*
+	 * tse_qsize: The number of host credits that may be used for data. This
+	 * value is static for the lifetime of the queue.
+	 *
+	 * tse_qsize_spg: The total number of host credits in the queue. This is
+	 * 1-2 more credits than tse_qsize to account for the status page at the
+	 * end of the queue. The status page credits cannot be used for sending
+	 * data, rather the beginning of the status page is considered the end
+	 * of the queue as far as the datapath is concerned.
+	 *
+	 * tse_avail: The number of host credits that are currently available
+	 * for use by the host. This is never more than 'tse_qsize - 1' in order
+	 * to avoid 'tse_pidx==tse_cidx' which we use to indicate an empty
+	 * queue. This number is updated as credits are used/recycled.
+	 *
+	 * tse_pending: The number of credits that have been written by the host
+	 * but still require a doorbell before the device can consume them. Said
+	 * another way, it's the number of credits the host's pidx is ahead of
+	 * the device's cidx.
+	 */
+	uint16_t tse_qsize;	/* Write Once */
+	uint16_t tse_qsize_spg;	/* Write Once */
+	uint16_t tse_avail;	/* tse_lock */
+	uint16_t tse_pending;	/* tse_lock */
 
-#define	FL_RUNNING_LOW(fl)	(fl->cap - fl->needed <= fl->lowat)
-#define	FL_NOT_RUNNING_LOW(fl)	(fl->cap - fl->needed >= 2 * fl->lowat)
+	/*
+	 * The pidx is the driver's position in the queue, pointing to the next
+	 * credit to consume. The cidx is the device's position in the queue,
+	 * pointing to the last credit it has consumed as of the last status
+	 * update.
+	 */
+	uint16_t tse_cidx;	/* tse_lock */
+	uint16_t tse_pidx;	/* tse_lock */
+
+	/* Doorbell bits */
+	t4_doorbells_t tse_doorbells; /* Write Once */
+	/* KVA of doorbell (lies within BAR2) */
+	caddr_t tse_udb;	/* Write Once */
+	/* relative qid within the doorbell page */
+	uint_t tse_udb_qid;	/* Write Once */
+
+	struct sge_qstat *tse_spg;	/* status page - Write Once */
+	/* IQ that gets egr_update msg for EQ */
+	uint16_t tse_iqid;		/* Write Once */
+	/* tx channel used by the EQ */
+	uint8_t tse_tx_chan;		/* Write Once */
+	/* SGE context id for the EQ */
+	uint32_t tse_cntxt_id;		/* Write Once */
+} t4_sge_eq_t;
+
+typedef enum t4_sfl_flags {
+	SFL_STARVING	= (1 << 0),	/* on the list of starving fl's */
+	SFL_DOOMED	= (1 << 1),	/* about to be destroyed */
+} t4_sfl_flags_t;
+
+struct sge_fl_stats {
+	/* These stats describe the receiving of data. */
+	uint64_t copy;		/* # of frames copied (allocb) */
+	uint64_t copy_fail;	/* # of allocb failures */
+	uint64_t wrap;		/* # of frames wrapped (desballoc) */
+	uint64_t wrap_fail;	/* # of deballoc failures */
+
+	/* These stats describe the refilling of rx (FL) buffers. */
+	uint64_t rxb_recycle;	/* # of rx buffers recycled */
+	uint64_t rxb_alloc;	/* # of rx buffers allocated */
+	uint64_t rxb_alloc_fail; /* # of rx buffers that failed to allocb */
+};
 
 struct sge_fl {
-	t4_fl_flags_t flags;
-	kmutex_t lock;
-	ddi_dma_handle_t dhdl;
-	ddi_acc_handle_t ahdl;
-
-	__be64 *desc;		/* KVA of descriptor ring, ptr to addresses */
-	uint64_t ba;		/* bus address of descriptor ring */
-	struct fl_sdesc *sdesc;	/* KVA of software descriptor ring */
-	uint32_t cap;		/* max # of buffers, for convenience */
-	uint16_t qsize;		/* size (# of entries) of the queue */
-	uint16_t cntxt_id;	/* SGE context id for the freelist */
-	uint32_t cidx;		/* consumer idx (buffer idx, NOT hw desc idx) */
-	uint32_t pidx;		/* producer idx (buffer idx, NOT hw desc idx) */
-	uint32_t needed;	/* # of buffers needed to fill up fl. */
-	uint32_t lowat;		/* # of buffers <= this means fl needs help */
-	uint32_t pending;	/* # of bufs allocated since last doorbell */
-	uint32_t offset;	/* current packet within the larger buffer */
-	uint16_t copy_threshold; /* anything this size or less is copied up */
+	/*
+	 * EQ for passing freelist entries to adapter.
+	 * Must be first field in struct
+	 */
+	t4_sge_eq_t eq;		/* Write Once */
+
+	/*
+	 * Index at which new buffers are to be placed in the FL descriptor
+	 * which is currently being produced for the device.
+	 */
+	uint8_t cidx_sdesc;	/* FL_LOCK */
+	uint8_t pidx_sdesc;	/* FL_LOCK */
+
+	/* KVA of the software descriptor ring. */
+	struct fl_sdesc *sdesc;	/* Write Once */
+	/* Total number of buffers in the FL.  */
+	uint32_t bufs_cap;	/* Write Once */
+	/*
+	 * Number of buffers available to receive data, buffers owned by the
+	 * device.
+	 */
+	uint32_t bufs_avail;	 /* FL_LOCK */
+	/* Number of buffers at which the FL is considered "starving". */
+	uint32_t bufs_lowat;	/* Write Once */
+	/* The byte offset in the current FL buffer. */
+	uint32_t offset;	/* FL_LOCK */
+	/* Any packet smaller or equal to this is copied (allocb). */
+	uint16_t copy_threshold; /* Write Once */
+
+	/* Starvation-related state for this freelist. */
+	t4_sfl_flags_t sfl_flags; /* adapter->sfl_lock */
+	list_node_t sfl_node;	  /* adapter->sfl_lock */
+
+	struct sge_fl_stats stats; /* FL_LOCK */
+};
 
-	uint64_t copied_up;	/* # of frames copied into mblk and handed up */
-	uint64_t passed_up;	/* # of frames wrapped in mblk and handed up */
-	uint64_t allocb_fail;	/* # of mblk allocation failures */
+struct sge_txq_stats {
+	/* stats for common events first */
+	uint64_t txpkts;	/* # of ethernet packets */
+	uint64_t txbytes;	/* # of ethernet bytes */
+	uint64_t txcsum;	/* # of times hardware assisted with checksum */
+	uint64_t tso_wrs;	/* # of IPv4 TSO work requests */
+	uint64_t imm_wrs;	/* # of work requests with immediate data */
+	uint64_t sgl_wrs;	/* # of work requests with direct SGL */
+	uint64_t txpkt_wrs;	/* # of txpkt work requests (not coalesced) */
+	uint64_t txpkts_wrs;	/* # of coalesced tx work requests */
+	uint64_t txpkts_pkts;	/* # of frames in coalesced tx work requests */
+	uint64_t txb_used;	/* # of tx copy buffers used (64 byte each) */
+	uint64_t hdl_used;	/* # of DMA handles used */
 
-	TAILQ_ENTRY(sge_fl) link; /* All starving freelists */
+	/* stats for not-that-common events */
+	uint32_t txb_full;	/* txb ran out of space */
+	uint32_t dma_hdl_failed; /* couldn't obtain DMA handle */
+	uint32_t dma_map_failed; /* couldn't obtain DMA mapping */
+	uint32_t qfull;		/* out of hardware descriptors */
+	uint32_t pullup_early;	/* # of pullups before starting frame's SGL */
+	uint32_t pullup_late;	/* # of pullups while building frame's SGL */
+	uint32_t pullup_failed;	/* # of failed pullups */
+	uint32_t csum_failed;	/* # of csum reqs we failed to fulfill */
 };
 
-/* txq: SGE egress queue + miscellaneous items */
+/* Ethernet packet transmission queue */
 struct sge_txq {
-	struct sge_eq eq;	/* MUST be first */
+	t4_sge_eq_t eq;
 
-	struct port_info *port;	/* the port this txq belongs to */
+	struct port_info *port;
 	struct tx_sdesc *sdesc;	/* KVA of software descriptor ring */
+
 	mac_ring_handle_t ring_handle;
 
 	/* DMA handles used for tx */
